<template>
  <div class="sidebar open" :style="cssVars">
    <div class="user_detail">
      <div class="icon d-flex align-items-center justify-content-center">
        <img src="../assets/img/profile_default.jpeg" />
      </div>
      <div class="user_name">
        {{ sesion.name }}
      </div>
      <div class="user_description">
        {{ sesion.description }}
      </div>
    </div>

    <div class="contenedor-nav">
      <div id="my-scroll">
        <ul class="nav-list" style="overflow: visible">
          <span v-for="(menuItem, index) in menuItems" :key="index">
            <li>
              <router-link :to="menuItem.link">
                <i class="bx" :class="menuItem.icon || 'bx-square-rounded'" />
                <span class="links_name">{{ menuItem.name }}</span>
              </router-link>
            </li>
          </span>
        </ul>
      </div>

      <div class="cerrar-sesion" @click="cerrarSesion">
        <span>Cerrar sesión</span>
        <i class="bx bx-log-out" id="log_out" />
      </div>
    </div>
  </div>
</template>

<script>
import { useSesionUsuario } from '../stores/user'
const sesionUsuario = useSesionUsuario()

export default {
  name: 'SidebarMenu',
  props: {
    menuTitle: {
      type: String,
      default: 'Rinku'
    },
    menuItems: {
      type: Array,
      default: () => [
        {
          link: '/employees',
          name: 'Empleados',
          icon: 'bx-user'
        },
        {
          link: '/movements',
          name: 'Movimientos',
          icon: 'bx-grid-alt'
        }
      ]
    },
    bgColor: {
      type: String,
      default: '#03254c'
    },
    homeSectionColor: {
      type: String,
      default: '#e4e9f7'
    },
    logoTitleColor: {
      type: String,
      default: '#fff'
    },
    iconsColor: {
      type: String,
      default: '#fff'
    },
    searchInputTextColor: {
      type: String,
      default: '#fff'
    },
    menuItemsHoverColor: {
      type: String,
      default: '#fff'
    },
    menuItemsTextColor: {
      type: String,
      default: '#fff'
    }
  },
  data() {
    return {
      sesion: {
        name: '',
        description: ''
      }
    }
  },
  beforeMount() {
    this.getSesion()
  },
  computed: {
    cssVars() {
      return {
        '--bg-color': this.bgColor,
        '--home-section-color': this.homeSectionColor,
        '--logo-title-color': this.logoTitleColor,
        '--icons-color': this.iconsColor,
        '--menu-items-hover-color': this.menuItemsHoverColor,
        '--menu-items-text-color': this.menuItemsTextColor
      }
    }
  },
  methods: {
    async cerrarSesion() {
      try {
        sesionUsuario.cerrarSesion()
        this.$router.push({ name: 'login' })
      } catch (error) {
        sesionUsuario.cerrarSesion()
        this.$router.push({ name: 'login' })
      }
    },
    getSesion() {
      this.sesion.name = sesionUsuario.getNombreUsuario
      this.sesion.description = sesionUsuario.getDescripcionRol
    }
  }
}
</script>

<style scoped>
.menu-logo {
  width: 30px;
  margin: 0 10px 0 10px;
}
.contenedor-nav {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  flex-grow: 1;
  max-height: calc(100% - 60px);
}
.sidebar {
  position: relative;
  display: flex;
  flex-direction: column;
  position: fixed;
  left: 0;
  top: 0;
  height: 100%;
  min-height: min-content;
  width: 78px;
  background: var(--bg-color);
  z-index: 99;
  transition: all 0.5s ease;
}
.sidebar.open {
  width: 250px;
}
.sidebar .user_detail {
  height: fit-content;
  display: flex;
  align-items: center;
  position: relative;
  flex-direction: column;
  padding: 25px 15px;
  border-bottom: 1px solid #fff;
}
.sidebar .user_detail .user_name {
  color: var(--logo-title-color);
  font-size: 20px;
  font-weight: 600;
  opacity: 0;
  transition: all 0.5s ease;
  width: 100%;
  text-align: center;
  margin-top: 10px;
}
.sidebar .user_detail .user_description {
  color: var(--logo-title-color);
  font-size: 14px;
  font-weight: 600;
  opacity: 0;
  transition: all 0.5s ease;
  width: 100%;
  text-align: center;
}
.sidebar.open .user_detail .user_name,
.sidebar.open .user_detail .user_description {
  opacity: 1;
}
.sidebar i {
  color: var(--icons-color);
  height: 60px;
  min-width: 50px;
  font-size: 28px;
  text-align: center;
  line-height: 60px;
}
.sidebar .nav-list {
  margin-top: 20px;
  padding-right: 2rem;
}
.sidebar li {
  position: relative;
  margin: 8px 0;
  list-style: none;
}
.sidebar li a {
  display: flex;
  height: 100%;
  width: 100%;
  border-radius: 12px;
  align-items: center;
  text-decoration: none;
  transition: all 0.4s ease;
  background: var(--bg-color);
}
.sidebar li a:hover {
  background: var(--menu-items-hover-color);
}
.sidebar li a .links_name {
  color: var(--menu-items-text-color);
  font-size: 15px;
  font-weight: 400;
  white-space: nowrap;
  opacity: 0;
  pointer-events: none;
  transition: 0.4s;
}
.sidebar.open li a .links_name {
  opacity: 1;
  pointer-events: auto;
}
.sidebar li a:hover .links_name,
.sidebar li a:hover i {
  transition: all 0.5s ease;
  color: var(--bg-color);
}
.sidebar li i {
  height: 50px;
  line-height: 50px;
  font-size: 18px;
  border-radius: 12px;
}
.home-section {
  position: relative;
  background: var(--home-section-color);
  min-height: 100vh;
  top: 0;
  left: 78px;
  width: calc(100% - 78px);
  transition: all 0.5s ease;
  z-index: 2;
}
.sidebar.open ~ .home-section {
  left: 250px;
  width: calc(100% - 250px);
}
.home-section .text {
  display: inline-block;
  color: var(--bg-color);
  font-size: 25px;
  font-weight: 500;
  margin: 18px;
}
.my-scroll {
  margin: 6px 14px 0 14px;
}
.my-scroll-active {
  overflow-y: auto;
}
#my-scroll {
  overflow-y: auto;
  height: calc(100% - 60px);
}
#my-scroll::-webkit-scrollbar {
  display: none;
}
.cerrar-sesion {
  padding: 0 2rem;
  display: flex;
  align-items: center;
  gap: 15px;
  color: #fff;
  cursor: pointer;
}
.cerrar-sesion:hover {
  color: #11101d;
  background-color: #fff;
}
.cerrar-sesion:hover i {
  color: #11101d;
}
img {
  width: 35%;
  border-radius: 50%;
}
</style>
